#include <amxmod>
#include <amxmisc>
#include <file>
#include <string>

#define MAX_MAPS 		128
#define MAX_MAP_NAME 		32
#define MAX_NOMINATED_MAPS	10
#define MAX_USERS		32
#define HUD_X			0.0
#define HUD_Y			0.88
#define HUD_X1			-1.0
#define HUD_Y1			0.1
#define TIME_TO_VOTE		300
#define TIME_TO_EXTEND		120
#define TIME_INTERVAL		3.0
#define MAX_MEMBER_MAPS		5
#define MAX_RESTRICT_LINE	256

new const CONFIG_FILE_NAME [] = "/custom/map_processor.cfg"
new const CONFIG_FILE_NAME1 [] = "/custom/map_processor.maps"
new const MAP_FILE_NAME [] = "/maps.ini"

new Maps_Names [ MAX_MAPS ] [ MAX_MAP_NAME ]
new Maps_Minimums [ MAX_MAPS ]
new Maps_Maximums [ MAX_MAPS ]
new Maps_Limits [ MAX_MAPS ]
new Maps_Restricts [ MAX_MAPS ] [ MAX_RESTRICT_LINE ]
new Known_Maps = 0
new Extend_Map_Menu_ID = 0
new Vote_Map_Menu_ID = 0
new Try_Vote_Menu_ID = 0
new Voting_Good_Answers = 0
new Extension_Menu [] = "This map is near to end."
new Voting_Menu [] = "Do you want to change map?"
new Try_Voting_Menu [] = "This map is not comfortable"
new Nominated_Maps [ MAX_NOMINATED_MAPS ] [ MAX_MAP_NAME ]
new Nominated_Counts [ MAX_NOMINATED_MAPS ]
new Nominated_Count = 0
new Nominate_User_Map [ MAX_USERS ] [ MAX_MAP_NAME ]
new Map_Voting_Stopped = 0
new Change_Map_At_Round_Start [ MAX_MAP_NAME ]
new Change_Map_Names [ MAX_USERS ] [ MAX_MAP_NAME ]
new Change_Map_Times [ MAX_USERS ]
new Voting_Map [ MAX_MAP_NAME ]
new Extending_Map [ MAX_USERS ]
new Time_To_Extend = 0
new Voting_Not_Need = 0
new Trying_Change_In_Progress = 0
new Trying_Change_Anss = 0
new Trying_Change_Annoy = 0
new Trying_Stop = 0
new Trying_Map [ MAX_MAP_NAME ]
new Map_For_Get_Next [ MAX_MAP_NAME ]
new Map_For_Try_Next [ MAX_MAP_NAME ]
new Time_Is_Out = 0
new Need_Start_Extension = 0
new Time_Of_The_Map = 0
new Map_Is_Selected = 0
new Dont_Defer_Load = 0
new Min_For_Skip_Vote = 0
new Max_For_Skip_Vote = 0
new Nominate_Limit = 5
new Was_Maps [ MAX_MEMBER_MAPS ] [ MAX_MAP_NAME ]
new Was_Maps_Counter
new Last_Map_Name [ MAX_MAP_NAME ]
new Min_Players_To_Queue = 6
new Maps_In_Queue
new Changed_By_Humans = 1
new Stop_Time_Corrector = 0
new Float:Real_Time_Limit = -1.0

//new const LOG_FILE_NAME [] = "map_processor.log"
//new Log_Buffer [ 128 ]
//public write_log_file ( String [] ) {
//	new Buffer [ 256 ]
//	new File_Name [ 128 ]
//
//	get_basedir ( File_Name, 127 )
//	add ( File_Name, 127, "/" )
//	add ( File_Name, 127, LOG_FILE_NAME )
//	get_time ( "%Y.%m.%d-%H:%M:%S : ", Buffer, 255 )
//	add ( Buffer, 255, String )
//	write_file ( File_Name, Buffer )
//}

public plugin_init() {
	new Map_Name [ MAX_MAP_NAME ]
	new Map_Name1 [ MAX_MAP_NAME ]
	new Tmp_String [ MAX_MEMBER_MAPS * MAX_MAP_NAME ]

	register_plugin("Map Processor","0.1.6","[BIL]")
	register_cvar ( "map_ratio", "0.5" )
	register_cvar ( "map_step", "15.0" )
	register_cvar ( "map_max", "60.0" )
	register_cvar ( "map_auto", "1.0" )
	register_cvar ( "map_disable_vote", "0.0" )
	register_cvar ( "map_disable_set", "0.0" )
	register_cvar ( "map_show_act", "1.0" )
	register_cvar ( "map_vote_answers", "1.0" )
        register_cvar ( "map_rotate_forever", "0.0" )
        register_cvar ( "map_dont_defer", "0.0" )
        register_cvar ( "map_min_skip_vote", "0.0" )
        register_cvar ( "map_max_skip_vote", "0.0" )
        register_cvar ( "map_nominate_max", "5.0" )
        register_cvar ( "map_min_maps_queue", "3.0" )
        register_cvar ( "map_min_queue_players", "6.0" )
        register_cvar ( "map_force_mapcycle", "1.0" )
        register_cvar ( "map_add_maps", "1.0" )
	register_cvar ( "amx_nextmap", "", FCVAR_SERVER | FCVAR_EXTDLL | FCVAR_SPONLY )
	get_basedir ( Tmp_String, 128 )
	add ( Tmp_String, 128, CONFIG_FILE_NAME )
	format ( Tmp_String, 128, "exec %s", Tmp_String )
	server_cmd ( Tmp_String )
	server_exec ()
	Extend_Map_Menu_ID = register_menuid ( Extension_Menu )
	register_menucmd ( Extend_Map_Menu_ID, ( 1 << 4 ) | ( 1 << 5 ) | ( 1 << 6 ) | ( 1 << 7 ) | ( 1 << 8 ) | ( 1 << 9 ), "Round_Menu_Response" )
	Vote_Map_Menu_ID = register_menuid ( Voting_Menu )
	register_menucmd ( Vote_Map_Menu_ID, ( 1 << 8 ) | ( 1 << 9 ), "Vote_Menu_Response" )
	Try_Vote_Menu_ID = register_menuid ( Try_Voting_Menu )
	register_menucmd ( Try_Vote_Menu_ID, ( 1 << 8 ) | ( 1 << 9 ), "Try_Vote_Response" )
	register_clcmd ( "map_nominate", "Nominate_Map", 0, "[map] - nominate map for next map voting or view nominated maps w/o map name" )
	register_clcmd ( "map_change", "Change_Map", 0, "[map] - try to change map or view tries w/o map name" )
	register_clcmd ( "map_set", "Set_Map", 0, "<map> - change map at round end" )
	register_clcmd ( "map_vote", "Vote_Map", 0, "<map> - start voting map" )
	register_clcmd ( "map_next", "View_Next_Map", 0, "- view next map set on current moment" )
	register_clcmd ( "say map_next", "View_Next_Map_Ch", 0, "- view next map set on current moment" )
	register_clcmd ( "map_extend", "Extend_Map", 0, "[min] - voting for map time extending. [min] for admins only" )
	register_clcmd ( "say map_extend", "Extend_Map_Ch", 0, "[min] - voting for map time extending. [min] for admins only" )
	register_clcmd ( "say nextmap","View_Next_Map_Ch",0,"- displays nextmap" )
	register_clcmd ( "map_list", "List_Maps", 0, "[phrase] - get list of cycled maps or all maps contain 'phrase'" )
	Clear_Vote_Resours ()
	for ( new i = 0; i < MAX_USERS; i++ ) {
		copy ( Change_Map_Names [ i ], 3, "" )
		Change_Map_Times [ i ] = -1
		Extending_Map [ i ] = 0
	}
	copy ( Change_Map_At_Round_Start, 3, "" )
	Time_Is_Out = 0
        Time_Of_The_Map = 0
	Time_To_Extend = 0
	get_mapname ( Map_Name1, MAX_MAP_NAME - 1 )
	copy ( Map_For_Get_Next, 2, "" )
	get_localinfo ( "map_processor_last", Map_For_Get_Next, MAX_MAP_NAME - 1 )
	if ( !strlen ( Map_For_Get_Next ) || ( !get_cvar_float ( "map_force_mapcycle" ) ) ) {
		get_mapname ( Map_For_Get_Next, MAX_MAP_NAME - 1 )
	}
	copy ( Map_For_Try_Next, MAX_MAP_NAME - 1, Map_For_Get_Next )
	Load_Info ()
	Get_Next_Map_Name ( Map_For_Get_Next, -1, Map_Name )
	if ( equal ( Map_Name, Map_Name1 ) ) {
		Get_Next_Map_Name ( Map_Name1, -1, Map_Name )
	}
	copy ( Map_For_Get_Next, MAX_MAP_NAME - 1, Map_Name )
	set_cvar_string ( "amx_nextmap", Map_Name )
	Voting_Not_Need = 0
        Trying_Change_In_Progress = 0
	Trying_Stop = 0
	Need_Start_Extension = 0
        Map_Is_Selected = 0
	Dont_Defer_Load = floatround ( get_cvar_float ( "map_dont_defer" ) )
	Min_For_Skip_Vote = floatround ( get_cvar_float ( "map_min_skip_vote" ) )
	Max_For_Skip_Vote = floatround ( get_cvar_float ( "map_max_skip_vote" ) )
        Maps_In_Queue = floatround ( get_cvar_float ( "map_min_maps_queue" ) )
        if ( ( Maps_In_Queue < 0 ) || ( Maps_In_Queue > MAX_MEMBER_MAPS ) ) { Maps_In_Queue = MAX_MEMBER_MAPS; }
        Min_Players_To_Queue = floatround ( get_cvar_float ( "map_min_queue_players" ) )
	Nominate_Limit = floatround ( get_cvar_float ( "map_nominate_max" ) )
	if ( ( Nominate_Limit > 7 ) || ( Nominate_Limit < 2 ) ) Nominate_Limit = 5
	copy ( Tmp_String, 2, "" )
	copy ( Last_Map_Name, 2, "" )
	get_localinfo ( "map_processor_maps", Tmp_String, MAX_MEMBER_MAPS * MAX_MAP_NAME - 1 )
	Was_Maps_Counter = parse ( Tmp_String, Was_Maps [ 0 ], MAX_MAP_NAME - 1, Was_Maps [ 1 ], MAX_MAP_NAME - 1, Was_Maps [ 2 ], MAX_MAP_NAME - 1, Was_Maps [ 3 ], MAX_MAP_NAME - 1, Was_Maps [ 4 ], MAX_MAP_NAME - 1 )
        Changed_By_Humans = 1
        Stop_Time_Corrector = 0
        copy ( Tmp_String, 3, "" )
	for ( new i = 0; i < Known_Maps; i++ ) {
		if ( equal ( Maps_Names [ i ], Map_Name1 ) ) {
			for ( new j = 0; j < strlen ( Maps_Restricts [ i ] ); j++ ) {
				if ( ( Maps_Restricts [ i ] [ j ] == ' ' ) || ( Maps_Restricts [ i ] [ j ] == '	' ) ) {
					if ( strlen ( Tmp_String ) ) {
						Exec_Command ( Tmp_String )
						copy ( Tmp_String, 3, "" )
					}
					continue
                                }
				add ( Tmp_String, MAX_MAP_NAME - 1, Maps_Restricts [ i ] [ j ], 1 )
			}
			if ( strlen ( Tmp_String ) )
				Exec_Command ( Tmp_String )
			break
		}
	}
	set_task ( 30.0, "Extension_Checker", 0, "", 0, "b" )
	set_task ( TIME_INTERVAL, "Time_Corrector", 0, "", 0, "b" )
	register_event( "SendAudio", "Round_Ended", "a", "2=%!MRAD_terwin", "2=%!MRAD_ctwin", "2=%!MRAD_rounddraw" );
	return PLUGIN_CONTINUE
}

public Exec_Command ( const Tmp_String [] ) {
	new Buffer [ 128 ]

	copy ( Buffer, 3, "" )
	if ( Tmp_String [ 0 ] == '-' )
		copy ( Buffer, 127, "amx_restrict on " )
	if ( Tmp_String [ 0 ] == '+' )
		copy ( Buffer, 127, "amx_restrict off " )
	add ( Buffer, 127, Tmp_String [ 1 ] )
	server_cmd ( Buffer )
}

public Round_Ended () {
	new Players = get_playersnum ()
	new Buffer [ 512 ]
	new Next_Map [ MAX_MAP_NAME ]

	if ( strlen ( Change_Map_At_Round_Start ) ) {
		set_cvar_string ( "amx_nextmap", Change_Map_At_Round_Start )
		set_hudmessage ( 100, 150, 100, HUD_X, HUD_Y, 0, 1.0, 4.0, 0.5, 0.5, 4 )
		show_hudmessage ( 0, "Changing map to '%s'...", Change_Map_At_Round_Start )
		set_task ( 4.0, "Change_Level" )
                Stop_Time_Corrector = 1
		set_cvar_float ( "mp_timelimit", get_cvar_float ( "mp_timelimit" ) + 1.0 )
		return PLUGIN_CONTINUE
	}
        if ( Need_Start_Extension ) {
		if ( ( Min_For_Skip_Vote <= Players <= Max_For_Skip_Vote ) ) {
			get_cvar_string ( "amx_nextmap", Next_Map, MAX_MAP_NAME - 1 )
			set_hudmessage ( 50, 200, 0, HUD_X, HUD_Y, 0, 2.0, 4.0, 2.0, 2.0, 4 )
			format ( Buffer, 127, "! Next map will be '%s'", Next_Map )
			show_hudmessage ( 0, Buffer )
			client_print ( 0, print_chat, Buffer )
			Map_Is_Selected = 1
			Voting_Not_Need = 1
			Need_Start_Extension = 0
			Changed_By_Humans = 0;
			return PLUGIN_CONTINUE
		}
		set_hudmessage ( 100, 200, 0, HUD_X1, HUD_Y1, 0, 2.0, 4.0, 2.0, 2.0, 4 )
		show_hudmessage ( 0, "Voting is about to begin..." )
		set_task ( 5.0, "Extension_Processor", 0, "", 0, "" )
        }
	return PLUGIN_CONTINUE
}

public client_connect ( id ) {
	new Index = Get_Index_For_Id ( id )
	if ( Index == -1 )
		return PLUGIN_CONTINUE
	copy ( Nominate_User_Map [ Index ], 3, "" )
	copy ( Change_Map_Names [ Index ], 3, "" )
	Change_Map_Times [ Index ] = -1
        Check_Map_Suitable ()
	return PLUGIN_CONTINUE
}

public client_disconnect ( id ) {
	new Index = Get_Index_For_Id ( id )
	if ( Index == -1 )
		return PLUGIN_CONTINUE
	copy ( Nominate_User_Map [ Index ], 3, "" )
	copy ( Change_Map_Names [ Index ], 3, "" )
	Change_Map_Times [ Index ] = -1
	Check_Map_Suitable ()
	return PLUGIN_CONTINUE
}

public Round_Menu_Response ( id, key ) {
	new Player_Name [ 32 ]
	new Map_Name [ MAX_MAP_NAME ]
	new Map_Index = key - 9 + Nominated_Count
	new Buffer [ 128 ]
		
	get_user_name ( id, Player_Name, 31 );
	if ( key == 9 ) {
		get_mapname ( Map_Name, MAX_MAP_NAME - 1 )
		Nominated_Counts [ MAX_NOMINATED_MAPS - 1 ]++
		format ( Buffer, 127, "* %s is voting for extending map '%s' (%d)", Player_Name, Map_Name, Nominated_Counts [ MAX_NOMINATED_MAPS - 1 ] )
	} else {
		Nominated_Counts [ Map_Index ]++
		format ( Buffer, 127, "* %s is voting for map '%s' (%d)", Player_Name, Nominated_Maps [ Map_Index ], Nominated_Counts [ Map_Index ] )
	}
	if ( get_cvar_float ( "map_vote_answers" ) )
		client_print ( 0, print_chat, Buffer )
	return PLUGIN_HANDLED
}

public Check_Map_Suitable () {
	new Map_Name [ MAX_MAP_NAME ]
	new Current_Players = get_playersnum ()

	if ( Trying_Stop )
		return 0
	if ( !get_cvar_float ( "map_auto" ) )
		return 0
	if ( Trying_Change_In_Progress )
		return 0
	if ( strlen ( Change_Map_At_Round_Start ) )
		return 0
	if ( !Current_Players )
		return 0
	get_mapname ( Map_Name, MAX_MAP_NAME - 1 )
	if ( Map_Is_Comfortable ( Map_Name, Current_Players ) )
		return 0
	Trying_Change_In_Progress = 1
	set_task ( 180.0, "Try_To_Change_Map" )
	return 0
}

public Extension_Processor () {
	new Buffer [ 512 ]
	new Keys = 0;
	new Next_Map [ MAX_MAP_NAME ]
	new Iterations = 0
	new Players = get_playersnum ()

	Map_Voting_Stopped = 1
	if ( strlen ( Change_Map_At_Round_Start ) ) {
		Map_Is_Selected = 1
		Voting_Not_Need = 1
		Need_Start_Extension = 0
		return PLUGIN_CONTINUE
        }
	Nominated_Count = 0;
	for ( new i = 0; i < MAX_USERS; i++ ) {
		if ( !strlen ( Nominate_User_Map [ i ] ) )
			continue;
		for ( new j = 0; j < MAX_NOMINATED_MAPS; j++ ) {
			if ( !strlen ( Nominated_Maps [ j ] ) ) {
				copy ( Nominated_Maps [ j ], MAX_MAP_NAME - 1, Nominate_User_Map [ i ] )
				Nominated_Counts [ j ] = 1
				Nominated_Count = j + 1
				break
			}
			if ( equal ( Nominated_Maps [ j ], Nominate_User_Map [ i ] ) ) {
				Nominated_Counts [ j ]++
				break
			}
		}
	}
	for ( new i = 1; i < Nominated_Count; i++ ) {
		for ( new j = 1; j < Nominated_Count; j++ ) {
			if ( Nominated_Counts [ j ] > Nominated_Counts [ j - 1 ] ) {
				new a = Nominated_Counts [ j - 1 ]
				
				Nominated_Counts [ j - 1 ] = Nominated_Counts [ j ]
				Nominated_Counts [ j ] = a
				copy ( Buffer, MAX_MAP_NAME - 1, Nominated_Maps [ j - 1 ] )
				copy ( Nominated_Maps [ j - 1 ], MAX_MAP_NAME - 1, Nominated_Maps [ j ] )
				copy ( Nominated_Maps [ j ], MAX_MAP_NAME - 1, Buffer )
			}
		}
	}
	if ( Nominated_Count > ( Nominate_Limit - 1 ) ) Nominated_Count = Nominate_Limit - 1;
	while ( ( Nominated_Count < Nominate_Limit ) && ( Iterations <= Known_Maps ) ) {
		new Found

		Get_Next_Map_Name ( Map_For_Get_Next, Players, Next_Map )
		Found = 0
		for ( new i = 0; i < Nominated_Count; i++ ) {
			if ( equal ( Nominated_Maps [ i ], Next_Map ) ) {
				Found = 1
				break
			}
		}
		for ( new i = 0; i < Was_Maps_Counter; i++ ) {
		 	if ( equal ( Was_Maps [ i ], Next_Map ) ) {
		 	 	Found = 1
		 	 	break
		 	}
		}
		if ( !Found )
			copy ( Nominated_Maps [ Nominated_Count++ ], MAX_MAP_NAME - 1, Next_Map )
		copy ( Map_For_Get_Next, MAX_MAP_NAME - 1, Next_Map )
		Iterations++
	}
	format ( Buffer, 511, "\y%s Select one of this:\w^n", Extension_Menu )
	for ( new i = 0; i < Nominated_Count; i++ ) {
		new SubBuffer [ 128 ]
		new Value = 10 - Nominated_Count + i;
		format ( SubBuffer, 127, "\y%d\w - change map to \y%s\w^n", Value, Nominated_Maps [ i ] )
		add ( Buffer, 511, SubBuffer );
		Keys |= 1 << ( Value - 1 )
	}
	new Max_Time = floatround ( get_cvar_float ( "map_max" ) )
	get_mapname ( Next_Map, MAX_MAP_NAME - 1 )
	for ( new i = 0; i < Known_Maps; i ++ ) {
 		if ( equal ( Maps_Names [ i ], Next_Map ) ) {
			Max_Time = Maps_Limits [ i ]
			break
 		}
	}
	new Can_Extend = ( get_cvar_float ( "mp_timelimit" ) < Max_Time ) ? 1 : 0
	if ( !Max_Time )
		Can_Extend = 1
	if ( Can_Extend ) {
		add ( Buffer, 511, "^n\y0\w - extend \ythis\w map^n" );
		Keys |= 1 << 9
	}
	for ( new i = 0; i < MAX_NOMINATED_MAPS; i++ )
		Nominated_Counts [ i ] = 0
	show_menu ( 0, Keys, Buffer, 15 )
	set_task ( 16.0, "Proc_Round_Results", 0, "", 0, "" )
	Voting_Not_Need = 1
	return PLUGIN_CONTINUE
}

public Extension_Checker () {
	new Time_Left = get_timeleft ()
	new Max_Time = floatround ( get_cvar_float ( "map_max" ) )
	new Next_Map [ MAX_MAP_NAME ]
	new Time_Limit = floatround ( get_cvar_float ( "mp_timelimit" ) )

	get_mapname ( Next_Map, MAX_MAP_NAME - 1 )
	for ( new i = 0; i < Known_Maps; i ++ ) {
 		if ( equal ( Maps_Names [ i ], Next_Map ) ) {
			Max_Time = Maps_Limits [ i ]
			break
 		}
	}
	new Can_Extend = ( Time_Limit < Max_Time ) ? 1 : 0
	if ( !Max_Time )
		Can_Extend = 1
	if ( Can_Extend ) {
		if ( ( TIME_TO_EXTEND < Time_Left < TIME_TO_VOTE ) && ( !strlen ( Change_Map_At_Round_Start ) ) ) {
			if ( !Time_To_Extend ) {
				set_hudmessage ( 120, 210, 0, HUD_X, HUD_Y, 2, 0.5, 5.0, 0.1, 0.1, 4 )
				show_hudmessage ( 0, "It's time to extend map" )
				Time_To_Extend = 1
			}
		} else {
			if ( Time_To_Extend ) {
				set_hudmessage ( 120, 210, 0, HUD_X, HUD_Y, 2, 0.5, 5.0, 0.1, 0.1, 4 )
				show_hudmessage ( 0, "Time for map extending is over" )
				Time_To_Extend = 0
			}
		}
	}
        if ( Map_Is_Selected || Need_Start_Extension || Voting_Not_Need || ( ( Time_Of_The_Map / 60 ) < ( Time_Limit - ( TIME_TO_EXTEND / 120 ) - get_cvar_float ( "mp_roundtime" ) ) ) || ( strlen ( Change_Map_At_Round_Start ) ) )
		return PLUGIN_CONTINUE
	Need_Start_Extension = 1
	return PLUGIN_CONTINUE
}

public Nominate_Map ( id, level ) {
	new My_Index
	new Buffer [ 128 ]
	new Map_Name [ MAX_MAP_NAME ]
	new SubBuffer [ 32 ]
	new Maps [ MAX_USERS ] [ MAX_MAP_NAME ]
	new Counts [ MAX_USERS ]
	new i, j
	new Players = get_playersnum ()
	
	if ( read_argc () == 1 ) {
		for ( i = 0; i < MAX_USERS; i++ ) {
                	copy ( Maps [ i ], 3, "" )
                	Counts [ i ] = 0
                }
		My_Index = 0
		for ( i = 0; i < MAX_USERS; i++ ) {
                	if ( strlen ( Nominate_User_Map [ i ] ) ) {
				My_Index++
				for ( j = 0; j < MAX_USERS; j++ ) {
					if ( !strlen ( Maps [ j ] ) ) {
					 	copy ( Maps [ j ], MAX_MAP_NAME - 1, Nominate_User_Map [ i ] )
					 	Counts [ j ] = 1
					 	break
					}
					if ( equal ( Maps [ j ], Nominate_User_Map [ i ] ) ) {
						Counts [ j ] ++
						break
					}
				}

                	}
                }
                if ( My_Index ) {
			format ( Buffer, 127, "Nominated %d maps:", My_Index )
			client_print ( id, print_console, Buffer )
	                for ( i = 0; i < MAX_USERS; i++ ) {
        	        	if ( Counts [ i ] ) {
					format ( Buffer, 127, "'%s' - %d times", Maps [ i ], Counts [ i ] )
					client_print ( id, print_console, Buffer )
				}
	                }
		} else {
			client_print ( id, print_console, "No maps nominated" )
                }
	} else {
		My_Index = Get_Index_For_Id ( id )
		if ( My_Index == -1 )
			return PLUGIN_HANDLED
		if ( Map_Voting_Stopped ) {
			client_print ( id, print_console, "Voting is now over" )
			return PLUGIN_HANDLED
		}
		if ( strlen ( Change_Map_At_Round_Start ) ) {
			client_print ( id, print_console, "It's too late" );
			return PLUGIN_HANDLED
		}
		if ( strlen ( Nominate_User_Map [ My_Index ] ) ) {
			client_print ( id, print_console, "You have done your choice (%s)", Nominate_User_Map [ My_Index ] )
			return PLUGIN_HANDLED
		}
		read_argv ( 1, Map_Name, MAX_MAP_NAME - 1 )
		if ( is_map_valid ( Map_Name ) ) {
			get_mapname ( Buffer, 127 )
			if ( equal ( Buffer, Map_Name ) ) {
				client_print ( id, print_console, "You can't nominate current map" )
			} else {
				j = -1
				for ( i = 0; i < Was_Maps_Counter; i++ ) {
					if ( equal ( Map_Name, Was_Maps [ i ] ) ) {
						j = i
						break
					}
				}
				if ( ( j == -1 ) || ( Players < Min_Players_To_Queue ) ) {
					copy ( Nominate_User_Map [ My_Index ], MAX_MAP_NAME - 1, Map_Name )
					get_user_name ( id, SubBuffer, 31 );
					client_print ( 0, print_chat, "* %s nominated map '%s' for voting next map", SubBuffer, Map_Name )
				} else {
					client_print ( id, print_console, "That map was played %d rounds ago, You can't nominate it now.", j + 1 )
				}
			}
		} else
			client_print ( id, print_console, "'%s' is bad map name", Map_Name )
	}
	return PLUGIN_HANDLED
}

public Proc_Round_Results () {
	new Next_Map_Name [ MAX_MAP_NAME ]
	new Win_Map [ MAX_MAP_NAME ]
	new Win_Counter = 0
	new Win_Type = -1
	new Buffer [ 128 ]

	Need_Start_Extension = 0
// round must not be less then 16 sec ;-)
	get_cvar_string ( "amx_nextmap", Next_Map_Name, MAX_MAP_NAME - 1 )
	for ( new i = 0; i < Nominated_Count; i++ ) {
		if ( Win_Counter < Nominated_Counts [ i ] ) {
			Win_Counter = Nominated_Counts [ i ]
			Win_Type = 2
			copy ( Win_Map, MAX_MAP_NAME - 1, Nominated_Maps [ i ] )
		}
	}
	if ( ( Nominated_Counts [ MAX_NOMINATED_MAPS - 1 ] >= Win_Counter ) ) {
		if ( Nominated_Counts [ MAX_NOMINATED_MAPS - 1 ] || ( !get_cvar_float ( "map_rotate_forever" ) ) ) {
			Win_Type = 1
			Win_Counter = Nominated_Counts [ MAX_NOMINATED_MAPS - 1 ]
		}
	}
	Clear_Vote_Resours ()
	if ( Win_Type == -1 ) {
		set_hudmessage ( 200, 50, 0, HUD_X, HUD_Y, 0, 2.0, 4.0, 2.0, 2.0, 4 )
		format ( Buffer, 127, "! The vote unsuccessful. Next map will be '%s'", Next_Map_Name )
                Map_Is_Selected = 1
	} else if ( Win_Type == 1 ) {
		new Float:steptime = get_cvar_float ( "map_step" )

		set_hudmessage ( 50, 200, 0, HUD_X, HUD_Y, 0, 2.0, 4.0, 2.0, 2.0, 4 )
		format ( Buffer, 127, "! Current map will be extended for %.0f minutes due to the vote", steptime )
		set_cvar_float ( "mp_timelimit", get_cvar_float ( "mp_timelimit" ) + steptime )
                Voting_Not_Need = 0
		for ( new i = 0; i < MAX_USERS; i++ )
			Extending_Map [ i ] = 0
	} else {
		set_hudmessage ( 50, 200, 0, HUD_X, HUD_Y, 0, 2.0, 4.0, 2.0, 2.0, 4 )
		format ( Buffer, 127, "! Next map will be '%s' due to the vote", Win_Map )
		set_cvar_string ( "amx_nextmap", Win_Map )
		Map_Is_Selected = 1
	}
	show_hudmessage ( 0, Buffer )
	client_print ( 0, print_chat, Buffer )
	return PLUGIN_HANDLED
}

public Clear_Vote_Resours () {
	for ( new i = 0; i < MAX_USERS; i++ )
		copy ( Nominate_User_Map [ i ], 3, "" )
	for ( new i = 0; i < MAX_NOMINATED_MAPS; i++ ) {
		copy ( Nominated_Maps [ i ], 3, "" )
		Nominated_Counts [ i ] = 0
	}
	Nominated_Count = 0
        Map_Voting_Stopped = 0
}

public Set_Map ( id ) {
	new Map_Name [ MAX_MAP_NAME ]
	new Player_Name [ MAX_MAP_NAME ]
	new Buffer [ 128 ]
	
	if ( get_cvar_float ( "map_disable_set" ) ) {
		client_print ( id, print_console, "This feature is disabled on the server" )
		return PLUGIN_HANDLED
	}
	copy ( Map_Name, 3, "" )
	read_argv ( 1, Map_Name, MAX_MAP_NAME - 1 )
	if ( !strlen ( Map_Name ) ) {
		client_print ( id, print_console, "You have to write map name to change" )
		return PLUGIN_HANDLED
	}
	if ( !( get_user_flags ( id ) & ADMIN_MAP ) ) {
		client_print ( id, print_console, "You have no permission to change map" )
		return PLUGIN_HANDLED
	}
	if ( !is_map_valid ( Map_Name ) ) {
		client_print ( id, print_console, "You wrote bad map name" )
		return PLUGIN_HANDLED
	}
	if ( get_cvar_float ( "map_show_act" ) ) {
		get_user_name ( id, Player_Name, MAX_MAP_NAME - 1 )
		client_print ( 0, print_chat, "* %s changes map to '%s'", Player_Name, Map_Name )
	} else {
		client_print ( 0, print_chat, "* Map will be changed to '%s'", Map_Name )
	}
	copy ( Change_Map_At_Round_Start, MAX_MAP_NAME - 1, Map_Name )
	set_cvar_string ( "amx_nextmap", Change_Map_At_Round_Start )
        Map_Is_Selected = 1
	set_hudmessage ( 127, 127, 0, HUD_X, HUD_Y, 0, 2.0, 4.0, 2.0, 2.0, 4 )
	format ( Buffer, 127, "! Map will be changed to '%s' at round end", Change_Map_At_Round_Start )
	show_hudmessage ( 0, Buffer )
	client_print ( 0, print_chat, Buffer )
	return PLUGIN_HANDLED
}

public Change_Map ( id, level ) {
	new My_Index
	new Buffer [ 128 ]
	new Index
	new Map_Name [ MAX_MAP_NAME ]
	new Counts [ MAX_USERS ]
	new Maps [ MAX_USERS ] [ MAX_MAP_NAME ]
	new i, j
	new Players = get_playersnum ()

/*	if ( ( Players >= Min_For_Skip_Vote ) && ( Players <= Max_For_Skip_Vote ) ) {
		client_print ( id, print_console, "Server is set to play mapcycle for that number of players" );
		return PLUGIN_HANDLED
	}*/
	if ( strlen ( Change_Map_At_Round_Start ) ) {
		client_print ( id, print_console, "It's too late" );
		return PLUGIN_HANDLED
	}
	Index = floatround ( get_cvar_float ( "map_ratio" ) * float ( get_playersnum () ) )
	if ( read_argc () == 1 ) {
		for ( i = 0; i < MAX_USERS; i++ ) {
                	copy ( Maps [ i ], 2, "" )
                	Counts [ i ] = 0
                }
		My_Index = 0
		for ( i = 0; i < MAX_USERS; i++ ) {
                	if ( strlen ( Change_Map_Names [ i ] ) ) {
				My_Index++
				for ( j = 0; j < MAX_USERS; j++ ) {
					if ( !strlen ( Maps [ j ] ) ) {
					 	copy ( Maps [ j ], MAX_MAP_NAME - 1, Change_Map_Names [ i ] )
					 	Counts [ j ] = 1
					 	break
					}
					if ( equal ( Maps [ j ], Change_Map_Names [ i ] ) ) {
						Counts [ j ] ++
						break
					}
				}

                	}
                }
                if ( My_Index ) {
			format ( Buffer, 127, "Maps for change:", My_Index )
			client_print ( id, print_console, Buffer )
	                for ( i = 0; i < MAX_USERS; i++ ) {
        	        	if ( Counts [ i ] ) {
					format ( Buffer, 127, "'%s' - (%d/%d)", Maps [ i ], Counts [ i ], Index )
					client_print ( id, print_console, Buffer )
				}       	
	                }
		} else {
			client_print ( id, print_console, "No maps set to change" )
                }
	} else {
		My_Index = Get_Index_For_Id ( id )
		if ( My_Index == -1 )
			return PLUGIN_HANDLED
		read_argv ( 1, Map_Name, MAX_MAP_NAME - 1 )
		if ( !is_map_valid ( Map_Name ) ) {
			client_print ( id, print_console, "'%s' is bad map name", Map_Name )
			return PLUGIN_HANDLED
		}
		if ( ( Change_Map_Times [ My_Index ] != -1 ) && ( Change_Map_Times [ My_Index ] + 3 ) > floatround ( get_gametime () ) ) {
			client_print ( id, print_console, "Don't flood, please" )
			return PLUGIN_HANDLED
		}
		j = -1
		for ( i = 0; i < Was_Maps_Counter; i++ ) {
			if ( equal ( Map_Name, Was_Maps [ i ] ) ) {
				j = i
				break
			}
		}
		if ( ( j != -1 ) && ( Players >= Min_Players_To_Queue ) ) {
			client_print ( id, print_console, "That map was played %d rounds ago, You can't change to one now.", j + 1 )
			return PLUGIN_HANDLED
		}
		Change_Map_Times [ My_Index ] = floatround ( get_gametime () )
		copy ( Change_Map_Names [ My_Index ], MAX_MAP_NAME - 1, Map_Name )
		get_user_name ( id, Buffer, 31 )
		My_Index = 0
		for ( i = 0; i < MAX_USERS; i++ ) {
	        	if ( equal ( Change_Map_Names [ i ], Map_Name ) )
	        		My_Index++
	        }
		client_print ( 0, print_chat, "* %s want to change map to '%s' (%d/%d)", Buffer, Map_Name, My_Index, Index )
		if ( My_Index >= Index ) {
			set_hudmessage ( 50, 200, 0, HUD_X, HUD_Y, 0, 2.0, 4.0, 2.0, 2.0, 4 )
			format ( Buffer, 127, "! Map will be changed to '%s' at next round start", Map_Name )
			show_hudmessage ( 0, Buffer )
			client_print ( 0, print_chat, Buffer )
			copy ( Change_Map_At_Round_Start, MAX_MAP_NAME - 1, Map_Name )
			set_cvar_string ( "amx_nextmap", Map_Name )
	                Map_Is_Selected = 1
		}
	}
	return PLUGIN_HANDLED
}

public Get_Index_For_Id ( id ) {
	if ( 0 <= id < MAX_USERS )
		return id
	return -1
}

public View_Next_Map_Ch ( id ) {
	return Make_View_Next ( id, 1 )
}

public View_Next_Map ( id ) {
	return Make_View_Next ( id, 0 )
}

public Make_View_Next ( id, type ) {
	new Buffer [ MAX_MAP_NAME ]
	new Out_Type = type ? print_chat : print_console
	
	if ( strlen ( Change_Map_At_Round_Start ) )
		copy ( Buffer, MAX_MAP_NAME - 1, Change_Map_At_Round_Start )
	else
		get_cvar_string ( "amx_nextmap", Buffer, MAX_MAP_NAME - 1 )
	client_print ( id, Out_Type, "Next map is set to '%s' for this time", Buffer )
	return PLUGIN_HANDLED
}

public Vote_Map ( id, level ) {
	new Map_Name [ MAX_MAP_NAME ]
	new Player_Name [ 32 ]

	if ( get_cvar_float ( "map_disable_vote" ) ) {
		client_print ( id, print_console, "This feature is disabled on the server" )
		return PLUGIN_HANDLED
	}
	copy ( Map_Name, 3, "" )
	read_argv ( 1, Map_Name, MAX_MAP_NAME - 1 )
	if ( !strlen ( Map_Name ) ) {
		client_print ( id, print_console, "You have to write map name to vote" )
		return PLUGIN_HANDLED
	}
	if ( !( get_user_flags ( id ) & ADMIN_MAP ) ) {
		client_print ( id, print_console, "You have no permission to vote map" )
		return PLUGIN_HANDLED
	}
	if ( !is_map_valid ( Map_Name ) ) {
		client_print ( id, print_console, "You wrote bad map name" )
		return PLUGIN_HANDLED
	}
	if ( get_cvar_float ( "map_show_act" ) ) {
		get_user_name ( id, Player_Name, 31 )
		client_print ( 0, print_chat, "* %s starts voting...", Player_Name )
	}
	set_hudmessage ( 100, 200, 0, HUD_X1, HUD_Y1, 0, 2.0, 4.0, 2.0, 2.0, 4 )
	show_hudmessage ( 0, "Voting is about to begin..." )
	set_task ( 5.0, "Vote_Map_Processor", 0, Map_Name, strlen ( Map_Name ) + 1, "" )
	return PLUGIN_HANDLED
}

public Vote_Map_Processor ( Map_Name [] ) {
	new Buffer [ 128 ]

	Voting_Good_Answers = 0
	copy ( Voting_Map, MAX_MAP_NAME - 1, Map_Name )
	format ( Buffer, 127, "\y%s^n^n\y9  -  change to \w%s^n\y0  -  \wDon't change", Voting_Menu, Map_Name )
	show_menu ( 0, ( 1 << 9 ) | ( 1 << 8 ), Buffer, 10 )
	set_task ( 12.0, "Proc_Vote_Results", 0, "", 0, "" )
	return PLUGIN_HANDLED
}

public Proc_Vote_Results () {
	new Deadline = floatround ( get_cvar_float ( "map_ratio" ) * float ( get_playersnum () ) )
	new Buffer [ 128 ]

	if ( Voting_Good_Answers >= Deadline ) {
		set_hudmessage ( 50, 200, 0, HUD_X, HUD_Y, 0, 2.0, 4.0, 2.0, 2.0, 4 )
		format ( Buffer, 127, "! Map will be changed to '%s' at next round start", Voting_Map )
		show_hudmessage ( 0, Buffer )
		client_print ( 0, print_chat, Buffer )
		copy ( Change_Map_At_Round_Start, MAX_MAP_NAME - 1, Voting_Map )
		set_cvar_string ( "amx_nextmap", Voting_Map )
                Map_Is_Selected = 1
	} else {
		set_hudmessage ( 200, 50, 0, HUD_X, HUD_Y, 0, 2.0, 4.0, 2.0, 2.0, 4 )
		show_hudmessage ( 0, "Voting is fail" )
	}
	return PLUGIN_HANDLED
}

public Vote_Menu_Response ( id, key ) {
	new Player_Name [ 32 ]
	new Buffer [ 128 ]
		
	get_user_name ( id, Player_Name, 31 );
	if ( key == 9 )
		format ( Buffer, 127, "- %s is voting against changing to that map", Player_Name )
	else {
		Voting_Good_Answers++
		format ( Buffer, 127, "+ %s is voting for changing to that map", Player_Name )
	}
	if ( get_cvar_float ( "map_vote_answers" ) )
		client_print ( 0, print_chat, Buffer )
	return PLUGIN_HANDLED
}

public Extend_Map_Ch ( id ) {
	return Make_Extend_Map ( id, 1 )
}

public Extend_Map ( id ) {
	return Make_Extend_Map ( id, 0 )
}

public Make_Extend_Map ( id, type ) {
	new Index = Get_Index_For_Id ( id )
	new Players = get_playersnum ()
	new Deadline = floatround ( get_cvar_float ( "map_ratio" ) * float ( Players ) )
	new Counter = 0
	new Buffer [ 128 ]
	new Out_Type = type ? print_chat : print_console
	new Time_For_Extend
	new User_Name [ 32 ]

	if ( read_argc () == 1 ) {
		Time_For_Extend = 0
	} else {
		read_argv ( 1, Buffer, 5 )
		Time_For_Extend = str_to_num ( Buffer )
		if ( Time_For_Extend < 0 || Time_For_Extend > 99 ) {
			Time_For_Extend = 0
		}
	}
	get_user_name ( id, User_Name, 31 )
	if ( Time_For_Extend ) {
		if ( !( get_user_flags ( id ) & ADMIN_MAP ) ) {
			client_print ( id, print_console, "You have no permission to extend map this way" )
			return PLUGIN_HANDLED
		}
		set_hudmessage ( 50, 200, 0, HUD_X, HUD_Y, 0, 2.0, 4.0, 2.0, 2.0, 4 )
		if ( get_cvar_float ( "map_show_act" ) ) {
			format ( Buffer, 127, "! Map will be extended for %d minutes by %s", Time_For_Extend, User_Name )
		} else {
			format ( Buffer, 127, "! Map will be extended for %d minutes", Time_For_Extend )
		}
		show_hudmessage ( 0, Buffer )
		client_print ( 0, print_chat, Buffer )
                copy ( Change_Map_At_Round_Start, 3, "" )
		set_cvar_float ( "mp_timelimit", get_cvar_float ( "mp_timelimit" ) + Time_For_Extend )
		Time_To_Extend = 0
		for ( new i = 0; i < MAX_USERS; i++ )
			Extending_Map [ i ] = 0
		return PLUGIN_HANDLED
	}
	if ( !Time_To_Extend ) {
		client_print ( id, Out_Type, "It's not a time now to extend map" )
		return PLUGIN_HANDLED	
	}
	if ( Index == -1 )
		return PLUGIN_HANDLED
	if ( Extending_Map [ Index ] ) {
		client_print ( id, Out_Type, "You already voted for extension" )
		return PLUGIN_HANDLED
	}
	Extending_Map [ Index ] = 1
	for ( new i = 0; i < MAX_USERS; i++ )
		if ( Extending_Map [ i ] )
			Counter++
	client_print ( 0, print_chat, "* %s is voting for extending this map (%d/%d)", User_Name, Counter, Deadline )
	if ( Counter >= Deadline ) {
		set_hudmessage ( 50, 200, 0, HUD_X, HUD_Y, 0, 2.0, 4.0, 2.0, 2.0, 4 )
		format ( Buffer, 127, "! Map will be extended for %.0f minutes", get_cvar_float ( "map_step" ) )
		show_hudmessage ( 0, Buffer )
		client_print ( 0, print_chat, Buffer )
                copy ( Change_Map_At_Round_Start, 3, "" )
		set_cvar_float ( "mp_timelimit", get_cvar_float ( "mp_timelimit" ) + get_cvar_float ( "map_step" ) )
		Time_To_Extend = 0
		for ( new i = 0; i < MAX_USERS; i++ )
			Extending_Map [ i ] = 0
	}
 	return PLUGIN_HANDLED
}

public Load_Info () {
	new Line_Index = 0
	new Length
	new Buffer [ 128 ]
	new Map_Cycle_File [ 128 ]
	new Parameter [ MAX_MAP_NAME ]
	new Value1 [ 5 ]
	new Value2 [ 5 ]
	new Value3 [ 5 ]
	new Value4 [ 256 ]
        new Elements
        new Max_Time = floatround ( get_cvar_float ( "map_max" ) )
        new Added
        new Restrict_Active = is_plugin_loaded ( "Restrict Weapons" )
        new Need_Add = floatround ( get_cvar_float ( "map_add_maps" ) )

        get_configsdir ( Map_Cycle_File, 127 )
        add ( Map_Cycle_File, 127, MAP_FILE_NAME )
	Known_Maps = 0
	while ( read_file ( Map_Cycle_File, Line_Index++, Buffer, 127, Length ) ) {
		Elements = parse ( Buffer, Parameter, MAX_MAP_NAME - 1 )
		if ( !Elements )
			continue
		if ( Parameter [ 0 ] == ';' )
			continue
		if ( is_map_valid ( Parameter ) ) {
			copy ( Maps_Names [ Known_Maps ], MAX_MAP_NAME - 1, Parameter )
			Maps_Minimums [ Known_Maps ] = 0
			Maps_Maximums [ Known_Maps ] = MAX_USERS
			Maps_Limits [ Known_Maps ] = Max_Time
			copy ( Maps_Restricts [ Known_Maps++ ], 3, "" )
			if ( Known_Maps >= MAX_MAPS )
				break
		}
	}
        Line_Index = 0
        get_basedir ( Map_Cycle_File, 127 )
        add ( Map_Cycle_File, 127, CONFIG_FILE_NAME1 )
	if ( file_exists ( Map_Cycle_File ) ) {
		while ( read_file ( Map_Cycle_File, Line_Index++, Buffer, 127, Length ) ) {
			Elements = parse ( Buffer, Parameter, MAX_MAP_NAME - 1, Value1, 4, Value2, 4, Value3, 4, Value4, MAX_RESTRICT_LINE - 1 )
			if ( !Elements )
				continue
			if ( Parameter [ 0 ] == ';' )
				continue
			if ( !is_map_valid ( Parameter ) )
				continue
			if ( Elements > 2 ) {
				new Limit = Max_Time
				new Restrict [ MAX_RESTRICT_LINE ]

				if ( Elements > 3 )
	                                Limit = strtonum ( Value3 );
				if ( Restrict_Active && ( Elements > 4 ) )
					copy ( Restrict, MAX_RESTRICT_LINE - 1, Value4 )
				else
					copy ( Restrict, 3, "" )
				Added = 0
				for ( new i = 0; i < Known_Maps; i ++ ) {
			 		if ( equal ( Maps_Names [ i ], Parameter ) ) {
			 			Added = 1
						Maps_Minimums [ i ] = strtonum ( Value1 )
						Maps_Maximums [ i ] = strtonum ( Value2 )
						Maps_Limits [ i ] = Limit
						copy ( Maps_Restricts [ i ], MAX_RESTRICT_LINE - 1, Restrict )
						break
			 		}
				}
				if ( Need_Add && !Added ) {
					if ( Known_Maps < MAX_MAPS ) {
			 			copy ( Maps_Names [ Known_Maps ], MAX_MAP_NAME - 1, Parameter )
						Maps_Minimums [ Known_Maps ] = strtonum ( Value1 );
						Maps_Maximums [ Known_Maps ] = strtonum ( Value2 );
						Maps_Limits [ Known_Maps ] = Limit
						copy ( Maps_Restricts [ Known_Maps++ ], MAX_RESTRICT_LINE - 1, Restrict )
			 		}
				}
			}
		}
	}
}

public Get_Next_Map_Name ( Current_Map [], Number_Of_Players, Next_Map [ MAX_MAP_NAME ] ) {
	new Current_Map_Index = 0
	new Old_Map_Index

	for ( new i = 0; i < Known_Maps; i++ ) {
		if ( equal ( Maps_Names [ i ], Current_Map ) ) {
		 	Current_Map_Index = i
		 	break
		}
	}
	Old_Map_Index = Current_Map_Index
	do {
		Current_Map_Index++
		if ( Current_Map_Index >= Known_Maps )
			Current_Map_Index = 0
		if ( Number_Of_Players < 1 )
			break
		if ( Maps_Minimums [ Current_Map_Index ] <= Number_Of_Players <= Maps_Maximums [ Current_Map_Index ] )
			break
	} while ( Old_Map_Index != Current_Map_Index )
	copy ( Next_Map, MAX_MAP_NAME - 1, Maps_Names [ Current_Map_Index ] )
}

public List_Maps ( id ) {
	new Buffer [ 128 ]
	new Line [ 83 ]
	new Index = 0
	new Length
	new All = 0
	new Pattern [ 32 ]

	if ( read_argc () == 2 )
		All = 1
        if ( !All ) {
	        copy ( Buffer, 127, "* Cyclic maps *" )
		for ( new i = 0; i < Known_Maps; i++ ) {
			if ( ( strlen ( Buffer ) + strlen ( Maps_Names [ i ] ) + 2 ) > 127 ) {
				client_print ( id, print_console, Buffer )
				copy ( Buffer, 3, "" )
			} else
				add ( Buffer, 127, "^n" )
			add ( Buffer, 127, Maps_Names [ i ] )
		}
		if ( strlen ( Buffer ) )  {
			client_print ( id, print_console, Buffer )
    		}
	} else {
		read_argv ( 1, Pattern, 31 )
		client_print ( id, print_console, "* Following maps contain '%s' *", Pattern );
		Index = 0
		copy ( Buffer, 3, "" )
		while ( ( Index = read_dir ( "maps", Index, Line, 80, Length ) ) ) {
			if ( ( Length = contain ( Line, ".bsp" ) ) == -1 )
				continue
			Line [ Length ] = 0
			if ( contain ( Line, Pattern ) == -1 )
				continue
			if ( ( strlen ( Buffer ) + strlen ( Line ) + 2 ) > 127 ) {
				client_print ( id, print_console, Buffer );
				copy ( Buffer, 3, "" )
			}
			if ( strlen ( Buffer ) )
				add ( Buffer, 127, "^n" )
			add ( Buffer, 127, Line )
		}
		if ( strlen ( Buffer ) ) 
			client_print ( id, print_console, Buffer );
	}
 	return PLUGIN_HANDLED
}

public Map_Is_Comfortable ( Map [], Players ) {
	new Min_Players = 0
	new Max_Players = get_maxplayers ()

	for ( new i = 0; i < Known_Maps; i++ ) {
		if ( equal ( Map, Maps_Names [ i ] ) ) {
		 	Min_Players = Maps_Minimums [ i ]
		 	Max_Players = Maps_Maximums [ i ]
		 	break
		}
	}
	if ( Min_Players <= Players <= Max_Players )
		return true
	return false
}

public Try_To_Change_Map () {
	new Next_Map [ MAX_MAP_NAME ]
	new Players = get_playersnum ()

	if ( strlen ( Change_Map_At_Round_Start ) )
        	return PLUGIN_CONTINUE
	if ( get_timeleft () <= TIME_TO_VOTE )
		return PLUGIN_CONTINUE
	Get_Next_Map_Name ( Map_For_Try_Next, Players, Next_Map )
	if ( equal ( Map_For_Try_Next, Next_Map ) )
		return PLUGIN_CONTINUE
	copy ( Map_For_Try_Next, MAX_MAP_NAME, Next_Map )
	set_hudmessage ( 100, 200, 0, HUD_X1, HUD_Y1, 0, 2.0, 4.0, 2.0, 2.0, 4 )
	show_hudmessage ( 0, "Voting is about to begin..." )
	set_task ( 5.0, "Try_To_Processor", 0, Next_Map, strlen ( Next_Map ) + 1, "" )
	return PLUGIN_CONTINUE
}

public Try_To_Processor	( Next_Map [] ) {
	new Buffer [ 128 ]

	copy ( Trying_Map, MAX_MAP_NAME - 1, Next_Map )
	Trying_Change_Anss = 0
	Trying_Change_Annoy = 0
	format ( Buffer, 127, "\y%s\w^nChange map to \y%s\w?^n\y8\w. Yes^n\y9\w. No^n\y0\w. Don't annoy", Try_Voting_Menu, Next_Map )
	show_menu ( 0, ( 1 << 9 ) | ( 1 << 8 ) | ( 1 << 7 ), Buffer, 10 )
	set_task ( 12.0, "Proc_Try_Vote", 0, "", 0, "" )
        Trying_Change_Anss = 0;
        return PLUGIN_HANDLED
}

public Proc_Try_Vote () {
	new Deadline = floatround ( get_cvar_float ( "map_ratio" ) * float ( get_playersnum () ) )
	Trying_Change_In_Progress = 0
	if ( Trying_Change_Anss >= Deadline ) {
		set_hudmessage ( 50, 200, 0, HUD_X, HUD_Y, 0, 2.0, 4.0, 2.0, 2.0, 4 )
		show_hudmessage ( 0, "Map will be changed to '%s' at next round start", Trying_Map )
		copy ( Change_Map_At_Round_Start, MAX_MAP_NAME - 1, Trying_Map )
		set_cvar_string ( "amx_nextmap", Trying_Map )
                Map_Is_Selected = 1
	} else if ( Trying_Change_Annoy >= Deadline ) {
		set_hudmessage ( 200, 50, 0, HUD_X, HUD_Y, 0, 2.0, 4.0, 2.0, 2.0, 4 )
		show_hudmessage ( 0, "Voting is fail. Server stops annoying for map change" )
		Trying_Stop = 1
	} else	{
		set_hudmessage ( 200, 50, 0, HUD_X, HUD_Y, 0, 2.0, 4.0, 2.0, 2.0, 4 )
		show_hudmessage ( 0, "Voting is fail" )
	}
	return PLUGIN_HANDLED
}

public Time_Corrector () {
	if ( Stop_Time_Corrector ) {
		return PLUGIN_CONTINUE
	}
        if ( Real_Time_Limit == -1.0 ) {
		Real_Time_Limit = get_cvar_float ( "mp_timelimit" )
        }
	Time_Of_The_Map = Time_Of_The_Map + floatround ( TIME_INTERVAL )
	if ( Time_Is_Out ) {
		if ( Time_Is_Out != -1 ) {
			Time_Is_Out = Time_Is_Out - floatround ( TIME_INTERVAL )
			if ( Time_Is_Out <= 0 ) {
				if ( Dont_Defer_Load ) {
					set_hudmessage ( 100, 150, 100, HUD_X, HUD_Y, 0, 1.0, 4.0, 0.5, 0.5, 4 )
					get_cvar_string ( "amx_nextmap", Change_Map_At_Round_Start, MAX_MAP_NAME - 1 )
					show_hudmessage ( 0, "Changing map to '%s'...", Change_Map_At_Round_Start )
					Changed_By_Humans = 0;
					Change_Level ()
				} else {
					set_hudmessage ( 200, 50, 0, HUD_X, HUD_Y, 0, 2.0, 4.0, 2.0, 2.0, 4 )
					show_hudmessage ( 0, "Time is out. Waiting for round end..." )
					if ( !strlen ( Change_Map_At_Round_Start ) ) {
						get_cvar_string ( "amx_nextmap",  Change_Map_At_Round_Start, MAX_MAP_NAME - 1 )
					}
				}
				Time_Is_Out = -1
			}
		}
	} else {
		if ( get_timeleft () <= ( 10.0 + TIME_INTERVAL ) ) {
			Time_Is_Out = get_timeleft ()
			if ( get_playersnum () ) {
				set_cvar_float ( "mp_timelimit", get_cvar_float ( "mp_timelimit" ) + get_cvar_float ( "mp_roundtime" ) + 1.0 )
			}
		}
	}
	return PLUGIN_CONTINUE
}

public Change_Level () {
	set_cvar_float ( "mp_timelimit", 0.1 )
	set_task ( 2.0, "Change_Level1" )
	return PLUGIN_CONTINUE
}

public Change_Level1 () {
	new Tmp_String [ MAX_MEMBER_MAPS * MAX_MAP_NAME ]

	if ( Was_Maps_Counter >= Maps_In_Queue ) {
		Was_Maps_Counter = Maps_In_Queue - 1
	}
	get_mapname ( Tmp_String, MAX_MEMBER_MAPS * MAX_MAP_NAME - 1 )
	for ( new i = 0; i < Was_Maps_Counter; i++ ) {
		add ( Tmp_String, MAX_MEMBER_MAPS * MAX_MAP_NAME - 1, " " )
		add ( Tmp_String, MAX_MEMBER_MAPS * MAX_MAP_NAME - 1, Was_Maps [ i ] )
	}
	set_localinfo ( "map_processor_maps", Tmp_String )
	get_cvar_string ( "amx_nextmap", Tmp_String, MAX_MAP_NAME - 1 )
	if ( !Changed_By_Humans ) {
		set_localinfo ( "map_processor_last", Tmp_String )
	}
	set_cvar_float ( "mp_timelimit", Real_Time_Limit )
	server_cmd ( "changelevel %s", Tmp_String )
	return PLUGIN_CONTINUE
}

public Try_Vote_Response ( id, key ) {
	new Player_Name [ 32 ]
	new Buffer [ 128 ]
		
	get_user_name ( id, Player_Name, 31 );
	if ( key == 9 ) {
		format ( Buffer, 127, "* %s is voting against changing and for stop annoying", Player_Name )
		Trying_Change_Annoy++
	} else 	if ( key == 8 ) {
		format ( Buffer, 127, "- %s is voting against changing to new map", Player_Name )
	} else {
		Trying_Change_Anss++
		format ( Buffer, 127, "+ %s is voting for changing to new map", Player_Name )
	}
	if ( get_cvar_float ( "map_vote_answers" ) )
		client_print ( 0, print_chat, Buffer )
	return PLUGIN_HANDLED
}

